#!/usr/bin/perl -w

# Autor: ActiveVB
# Ansprechpartner: Jochen Wierum (JoWi@ActiveVB.de)

# Diese Datei ist lediglich ein Grundgerst. Sie ist nicht funktionsfhig.
# Das Originalscript funktioniert nur auf dem AVB-Server, in Zusammenhang
# mit dem AVB-Club.

################################################################
# Aufruf:
# messenger.pl?v=%version%&cmd=%command%&...
#
# Der Parameter "v" enthlt die Version des Messengers im Format %i.%i.%i
# Command kann eines der folgenden Kommandos sein:
#	-login
#		Parameter	Bedeutung
#		name 		Namen des Benutzers, der angemeldet werden soll
#		pw		Das Passwort, gehrend zum Name
#		lanip		IP des Benutzers im Lan
#		state		Benutzerstatus (abwesend, etc)
#
#	-logout
#		Parameter	Bedeutung
#		sessid		Die beim Login zurckgegebene Sessionid
#
#	-refresh
#		Parameter	Bedeutung
#		sessid		Die beim Login zurckgegebene Sessionid
#		state		Benutzerstatus (abwesend, etc)
#


################################################################
# Rckgabe:
# Neben einem HTTP-Header erfolgt eine einfache Textausgabe:
# Die erste Zeile enthlt "OK" oder "ERR", gefolgt von der IP-Adresse des Senders.
# Diese Zeile sollte selbsterklrend sein.
#
# Sollte der Rckgabewert "ERR" sein, folgt evtl. eine Erklrung.
# Wenn der Rckgabewert "OK" sein soltle, gibt es mehrere Mglichkeiten, wie die Zeilen danach aussehen knnten:
#
#	cmd=login
#		Es folgt eine Liste aller angemeldeten Benutzer im Format "USER|lanip|status|ip|username".
#		Auerdem wird der Refreshinterval in der Form "PARAM|Refresh|zeit".
#		Der Parameter "PARAM|SESSID|sessionsid" gibt die neue Sessions-Id zurck
#
#	cmd=logout
#
#	cmd=refresh
#		Wie login



# HTTP-Header
# mehr brauchen wir nicht...
print "Content-Type: text/plain\n\n";



# importieren von weiteren Funktionen
use strict;
use warnings;
use CGI qw(:param);
use Fcntl ':flock';
use Digest::MD5;



# Timeout in Minuten
my $timeout = 15;



# "Versuche", nicht vorhandene Datei zu erstellen
if(!-f 'messenger.dat'){open(FILE, '>messenger.dat'); close FILE;}



# Die IP-Adresse des Aufrufers
my $ip = $ENV{'REMOTE_ADDR'};
if (!defined($ip)){
	$ip = '127.0.0.1';
	print &out('ERR', $ip, -1, 'Interner Fehler! Vermisse CGI-Variablen'); exit;
}



# Die Version
my $version = param('v');
if(!defined($version)){
	$version = '0.0.0';
}
my @version = split(/\./, $version);
if($#version != 2){
	print &out('ERR', $ip, 1, 'Falscher Aufruf'); exit;
}



# Versionsprfung - sollte vor allem anderen kommen!
if($version[0] != 1 || $version[1] != 0 || $version[2] != 0){
	print &out('ERR', $ip, 5, 'Falsche Version - Server und Client stimmen nicht berein!', "$version[0].$version[1].$version[2]", '1.0.0'); exit;
}



# Der Username
my $name = param('name');
if (!defined($name)){
	$name='';
}



# Das Passwort
my $pw = param('pw');
if (!defined($pw)){
	$pw = '';
}



# Die Sessionid
my $sessid = param('sessid');
if(!defined($sessid)){
	$sessid='';
}



# Der Status
my $status = param('state');
if(!defined($status)){
	$status = -1;
}



# Lan-ip
my $lanip = param('lanip');
if(!defined($lanip)){
	$lanip = '';
}



# Parameterabfrage
if(!defined(param('cmd'))){
	print &out('ERR', $ip, 1, 'Falscher Aufruf'); exit;
}



# Sicherheitshalber die Lnge von Name und Passwort auf 64 Zeichen beschrnken
if(length($name) > 64 || length($pw) > 64){
	print &out('ERR', $ip, 4, 'Fehler in Benutzername oder Passwort'); exit;
}



# Die brauchen wir gleich noch fters
my ($timestamp, $userlanip, $userstatus, $userip, $username, $usersessid);



&checktimeout;



# Login
if(lc param('cmd') eq 'login'){
	if($name eq '' || $pw eq '' || $lanip eq '' || $status == -1){
		print &out('ERR', $ip, 1, 'Falscher Aufruf'); exit;
	}
	
	# Dieser Kommentar entstand am 7. August 2004 auf dem ActiveVB-Treffen in Kln und
	# wurde von Florian Rittmeier geschrieben. Bitte nicht lschen!
	# <<
	#
	# Walle, walle manche Stecke,
	# dass zum Zwecke Wasser fliee
	# und in hohem, vollen Schwalle
	# zu dem Bade sich ergiee.
	#
	# Goethe - Der Zauberlehrling
	#
	# >>
	
	# Benutzer verifizieren
	if(
		!($name eq 'name' && $pw eq 'passwort') &&
		!($name eq 'user' && $pw eq 'geheim') &&
		!($name eq 'betatester' && $pw eq 'keines')
	){
		print &out('ERR', $ip, 2, 'Der Benutzername oder das Passwort ist falsch'); exit;
	}

	$sessid = &createsessid();

	# Datei ffnen (R/W)
	if(!open(FILE, '+<messenger.dat')){
		print &out('ERR', $ip, -1, "Interner Fehler! Konnte messenger.dat nicht ffnen ($!)"); exit;
	}

	# Es darf immer nur ein Zugriff auf die Datei erfolgen.
	# Daher wird gewartet, bis die Datei freigegeben ist.
	# Anschlieend wird sie wieder gesperrt, damit wir in Ruhe arbeiten knnen.
	flock FILE, LOCK_EX;

	# Datei einlesen
	chomp(my @lines = <FILE>);

	# Dateilnge auf 0 setzen
	seek FILE, 0, 0;
	truncate FILE, 0;

	print &out('OK', $ip);

	# Die Datei zeilenweise einlesen
	foreach(@lines){
		# Zeile in IP und Benutzernamen aufteilen
		($timestamp, $userlanip, $userstatus, $userip, $username, $usersessid) = split(/\t/, $_); 
		
		# Wenn dies nicht unser Benutzer ist
		# (sollte er bereits angemeldet sein, wird die IP aktualisiert)
		if($username ne $name){

			# Ausgeben und speichern
			print &out('USER', $userlanip, $userstatus, $userip, $username);
			print FILE $_ . "\n";
		}
	}

	# Zuletzt eigene IP hinzufgen
	print FILE join("\t", (time, $lanip, $status, $ip, $name, $sessid));

	# Die Refresh-Zeit mit angeben
	print &out('PARAM', 'Refresh', $timeout);
	print &out('PARAM', 'SESSID', $sessid);

	# Datei entsperren und schlieen
	flock FILE, LOCK_UN;
	close FILE;



# Logout
}elsif(lc param('cmd') eq 'logout'){
	if($sessid eq ''){
		print &out('ERR', $ip, 1, 'Falscher Aufruf'); exit;
	}

	# Datei ffnen
	if(!open(FILE, '+<messenger.dat')){
		print &out('ERR', $ip, -1, "Interner Fehler! Konnte messenger.dat nicht ffnen ($!)"); exit;
	}

	# Es darf immer nur ein Zugriff auf die Datei erfolgen.
	# Daher wird gewartet, bis die Datei freigegeben ist.
	# Anschlieend wird sie wieder gesperrt, damit wir in Ruhe arbeiten knnen.
	flock FILE, LOCK_EX;

	# Datei einlesen
	chomp(my @lines = <FILE>);

	# Dateilnge auf 0 setzen
	seek FILE, 0, 0;
	truncate FILE, 0;

	# Die Datei zeilenweise einlesen
	foreach(@lines){
		# Zeile in IP und Benutzernamen aufteilen
		($timestamp, $userlanip, $userstatus, $userip, $username, $usersessid) = split(/\t/, $_);
		
		# Wenn dies nicht unser User ist
		if($usersessid ne $sessid){
			# Speichern
			print FILE $_ . "\n";
		}
	}

	# Datei entsperren und schlieen
	flock FILE, LOCK_UN;
	close FILE;

	print &out('OK', $ip);



# Refresh
}elsif(lc param('cmd') eq 'refresh'){
	if($sessid eq '' || $status == -1){
		print &out('ERR', $ip, 1, 'Falscher Aufruf'); exit;
	}
	
	if(!open(FILE, '+<messenger.dat')){
		print &out('ERR', $ip, -1, "Interner Fehler! Konnte messenger.dat nicht ffnen ($!)"); exit;
	}

	# Es darf immer nur ein Zugriff auf die Datei erfolgen.
	# Daher wird gewartet, bis die Datei freigegeben ist. Anschlieend wird sie wieder gesperrt, damit wir in Ruhe arbeiten knnen.
	flock FILE, LOCK_EX;

	# Datei einlesen
	chomp(my @lines = <FILE>);

	seek FILE, 0, 0;
	truncate FILE, 0;

	print &out('OK', $ip);

	my $loggedin = 0;
	my $send = '';
	
	# Die Datei zeilenweise einlesen
	foreach(@lines){
		# Zeile in IP und Benutzernamen aufteilen
		($timestamp, $userlanip, $userstatus, $userip, $username, $usersessid) = split(/\t/, $_);

		# Wenn dies  unser Benutzer ist
		if($sessid eq $usersessid){
			
			# Neue Daten (status, IP) speichern
			print FILE join("\t", ($timestamp, $userlanip, $status, $ip, $username, $usersessid));
			
			# Ist gemeldet! Merken!
			$loggedin = 1;

		# Wenn nicht
		}else{
			# Speichern
			$send .= &out('USER', $userlanip, $userstatus, $userip, $username);
			print FILE "$_\n";			
		}
	}
	
	# Wenn der Benutzer eingeloggt ist, senden
	if($loggedin == 1){
		print $send;
		print &out('PARAM', 'Refresh', $timeout);
		print &out('PARAM', 'SESSID', $sessid);
	}
	
	# Datei entsperren und schlieen
	flock FILE, LOCK_UN;
	close FILE;


# Alles andere -> Fehler!
}else{
	print &out('ERR', $ip, 1, 'Falscher Aufruf');
}



# Formatiert ein Array in eine vernnftige Ausgabe
sub out(){
	my @out=@_;
	my $out;

	foreach(@out){
		$out .= "|$_" if($out);
		$out = $_ unless($out);
	}

	$out .= "\r\n";
	return $out;
}


# Hat sich ein Benutzer zu lange nicht mehr gemeldet?
sub checktimeout(){	
	my $now = time;
	my @out;
	
	if(!open(FILE, '+<messenger.dat')){
		print &out('ERR', $ip, -1, 'Interner Fehler! Konnte messenger.dat nicht ffnen ($!)'); exit;
	}

	# Es darf immer nur ein Zugriff auf die Datei erfolgen.
	# Daher wird gewartet, bis die Datei freigegeben ist. Anschlieend wird sie wieder gesperrt,
	# damit wir in Ruhe arbeiten knnen.
	flock FILE, LOCK_EX;

	# Datei einlesen
	chomp(my @lines = <FILE>);
	
	# Die Datei zurcksetzen
	seek FILE, 0, 0;
	truncate FILE, 0;
	
	# Die Datei zeilenweise einlesen
	foreach(@lines){
		
		# Zeile in IP und Benutzernamen aufteilen
		($timestamp, $userlanip, $userstatus, $userip, $username, $usersessid) = split(/\t/, $_);
		
		if($sessid ne $usersessid){
			# Letzte Meldung ist weniger als $timeout Minuten (+5 Minuten Varianz) her?
			if(($now - $timestamp) / 60 < ($timeout + 5)){
				print FILE $_ . "\n";
			}
			
		} elsif($sessid ne '') {
			# Unser Benutzer!
			print FILE join("\t", ($now, $userlanip, $userstatus, $userip, $username, $usersessid));
		}
	}

	# Datei entsperren und schlieen
	flock FILE, LOCK_UN;
	close FILE;
}

# Diese Funktion ist SO nicht SICHER und sollte unbedingt ersetzt werden!
sub createsessid{
	my $md5 = Digest::MD5->new;
	$md5->add(time, $ip, $name);
	return $md5->hexdigest;
}
